/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.konfigass;

/**
 * Kapselt die Daten eines Betriebsmeldungseintrags.
 * 
 * @version $Revision: 1.2 $ / $Date: 2011/01/17 10:06:18 $ / ($Author: Sans $)
 * @author HofmannJ
 * 
 */
public class Meldung
{
  /**
   * Pid dieses Objekts im DaV
   */
  private String _pid = null;

  /**
   * Zeitstempel
   */
  private String _zeitStempel = null;

  /**
   * ApplikationsID
   */
  private String _ApplikationsID = null;

  /**
   * LaufendeNummer
   */
  private String _LaufendeNummer = null;

  /**
   * ApplikationsTyp
   */
  private String _ApplikationsTyp = null;

  /**
   * ApplikationsKennung
   */
  private String _ApplikationsKennung = null;

  /**
   * ID
   */
  private String _ID = null;

  /**
   * MeldungsTyp
   */
  private String _MeldungsTyp = null;

  /**
   * MeldungsTypZusatz
   */
  private String _MeldungsTypZusatz = null;

  /**
   * MeldungsKlasse
   */
  private String _MeldungsKlasse = null;

  /**
   * Referenz [..1]
   */
  private String _Referenz = null;

  /**
   * Status
   */
  private String _Status = null;

  /**
   * Urlasser.BenutzerReferenz
   */
  private String _UrlasserBenutzerReferenz = null;

  /**
   * Urlasser.Ursache
   */
  private String _UrlasserUrsache = null;

  /**
   * Urlasser.Veranlasser
   */
  private String _UrlasserVeranlasser = null;

  /**
   * MeldungsText
   */
  private String _MeldungsText = null;

  /**
   * Liefert die Pid diese Objekts im DaV
   * 
   */
  public String getPid()
  {
    return _pid;
  }

  /**
   * Setzt die Pid dieses Objekts im DaV
   * 
   * @param pid
   *          Pid.
   */
  public void setPid(String pid)
  {
    _pid = pid;
  }

  /**
   * Setzt den Zeitstempel.
   * 
   * @param zeitstempel
   *          Zeitstempel.
   */
  public void setZeitStempel(String zeitstempel)
  {
    this._zeitStempel = zeitstempel;
  }

  /**
   * Liefert den Zeitstempel.
   * 
   * @return Zeitstempel.
   */
  public String getZeitStempel()
  {
    return _zeitStempel;
  }

  /**
   * Liefert die ApplikationsID.
   * 
   * @return ApplikationsID
   */
  public String getApplikationsID()
  {
    return _ApplikationsID;
  }

  /**
   * Setzt die ApplikationsID.
   * 
   * @param applikationsID
   *          ApplikationsID.
   */
  public void setApplikationsID(String applikationsID)
  {
    _ApplikationsID = applikationsID;
  }

  /**
   * Liefert die LaufendeNummer.
   * 
   * @return LaufendeNummer.
   */
  public String getLaufendeNummer()
  {
    return _LaufendeNummer;
  }

  /**
   * Setzt die LaufendeNummer.
   * 
   * @param laufendeNummer
   *          LaufendeNummer.
   */
  public void setLaufendeNummer(String laufendeNummer)
  {
    _LaufendeNummer = laufendeNummer;
  }

  /**
   * Liefert den ApplikationsTyp.
   * 
   * @return ApplikationsTyp.
   */
  public String getApplikationsTyp()
  {
    return _ApplikationsTyp;
  }

  /**
   * Setzt den ApplikationsTyp.
   * 
   * @param applikationsTyp
   *          ApplikationsTyp.
   */
  public void setApplikationsTyp(String applikationsTyp)
  {
    _ApplikationsTyp = applikationsTyp;
  }

  /**
   * Liefert die ApplikationsKennung.
   * 
   * @return ApplikationsKennung.
   */
  public String getApplikationsKennung()
  {
    return _ApplikationsKennung;
  }

  /**
   * Setzt die ApplikationsKennung.
   * 
   * @param applikationsKennung
   *          ApplikationsKennung.
   */
  public void setApplikationsKennung(String applikationsKennung)
  {
    _ApplikationsKennung = applikationsKennung;
  }

  /**
   * Liefert die ID.
   * 
   * @return ID.
   */
  public String getID()
  {
    return _ID;
  }

  /**
   * Setzt die ID.
   * 
   * @param id
   *          ID.
   */
  public void setID(String id)
  {
    _ID = id;
  }

  /**
   * Liefert den MeldungsTyp.
   * 
   * @return MeldungsTyp.
   */
  public String getMeldungsTyp()
  {
    return _MeldungsTyp;
  }

  /**
   * Setzt den MeldungsTyp.
   * 
   * @param meldungsTyp
   *          MeldungsTyp.
   */
  public void setMeldungsTyp(String meldungsTyp)
  {
    _MeldungsTyp = meldungsTyp;
  }

  /**
   * Liefert den MeldungsTypZusatz.
   * 
   * @return MeldungsTypZusatz.
   */
  public String getMeldungsTypZusatz()
  {
    return _MeldungsTypZusatz;
  }

  /**
   * Setzt den MeldungsTypZusatz.
   * 
   * @param meldungsTypZusatz
   *          MeldungsTypZusatz.
   */
  public void setMeldungsTypZusatz(String meldungsTypZusatz)
  {
    _MeldungsTypZusatz = meldungsTypZusatz;
  }

  /**
   * Liefert die MeldungsKlasse.
   * 
   * @return MeldungsKlasse.
   */
  public String getMeldungsKlasse()
  {
    return _MeldungsKlasse;
  }

  /**
   * Setzt die MeldungsKlasse.
   * 
   * @param meldungsKlasse
   *          MeldungsKlasse.
   */
  public void setMeldungsKlasse(String meldungsKlasse)
  {
    _MeldungsKlasse = meldungsKlasse;
  }

  /**
   * Liefert die Referenz.
   * 
   * @return Referenz.
   */
  public String getReferenz()
  {
    return _Referenz;
  }

  /**
   * Setzt die Referenz.
   * 
   * @param referenz
   *          Referenz.
   */
  public void setReferenz(String referenz)
  {
    _Referenz = referenz;
  }

  /**
   * Liefert den Status.
   * 
   * @return Status.
   */
  public String getStatus()
  {
    return _Status;
  }

  /**
   * Setzt den Status.
   * 
   * @param status
   *          Status.
   */
  public void setStatus(String status)
  {
    _Status = status;
  }

  /**
   * Liefert die Urlasser.BenutzerReferenz.
   * 
   * @return Urlasser.BenutzerReferenz.
   */
  public String getUrlasserBenutzerReferenz()
  {
    return _UrlasserBenutzerReferenz;
  }

  /**
   * Setzt die Urlasser.BenutzerReferenz.
   * 
   * @param urlasser_BenutzerReferenz
   *          Urlasser.BenutzerReferenz.
   */
  public void setUrlasserBenutzerReferenz(String urlasser_BenutzerReferenz)
  {
    _UrlasserBenutzerReferenz = urlasser_BenutzerReferenz;
  }

  /**
   * Liefert die Urlasser.Ursache().
   * 
   * @return Urlasser.Ursache().
   */
  public String getUrlasserUrsache()
  {
    return _UrlasserUrsache;
  }

  /**
   * Setzt die Urlasser.Ursache().
   * 
   * @param urlasser_Ursache
   *          Urlasser.Ursache().
   */
  public void setUrlasserUrsache(String urlasser_Ursache)
  {
    _UrlasserUrsache = urlasser_Ursache;
  }

  /**
   * Liefert den Urlasser.Veranlasser.
   * 
   * @return Urlasser.Veranlasser.
   */
  public String getUrlasserVeranlasser()
  {
    return _UrlasserVeranlasser;
  }

  /**
   * Setzt den Urlasser.Veranlasser.
   * 
   * @param urlasser_Veranlasser
   *          Urlasser.Veranlasser.
   */
  public void setUrlasserVeranlasser(String urlasser_Veranlasser)
  {
    _UrlasserVeranlasser = urlasser_Veranlasser;
  }

  /**
   * Liefert den MeldungsText.
   * 
   * @return Setzt den MeldungsText.
   */
  public String getMeldungsText()
  {
    return _MeldungsText;
  }

  /**
   * Setzt den MeldungsText.
   * 
   * @param meldungsText
   *          MeldungsText.
   */
  public void setMeldungsText(String meldungsText)
  {
    _MeldungsText = meldungsText;
  }

}
