/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.konfigass.assistenten;

import java.io.File;
import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.util.List;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.MultiStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.jface.dialogs.IDialogPage;
import org.eclipse.jface.operation.IRunnableWithProgress;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.IWizardPage;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.DirectoryDialog;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.PlatformUI;

import de.bsvrz.buv.plugin.konfigass.Activator;
import de.bsvrz.buv.plugin.konfigass.KonfigAssDateiOperationen;
import de.bsvrz.buv.plugin.konfigass.MeldungenSpeicher;
import de.bsvrz.puk.config.main.managementfile.ConfigurationAreaManagementInfo;
import de.bsvrz.puk.config.main.managementfile.ManagementFile;

/**
 * Class representing the first page of the wizard
 */

public class KvAoeNeuStartSeite extends WizardPage implements Listener
{
  IWorkbench workbench;

  IStructuredSelection selection;

  Button kvButton;

  Button aoeButton;

  // status variable for the possible errors on this page
  // timeStatus holds an error if the return date is before the departure date
  IStatus timeStatus;

  // holds an error is the destination and departure fields are the same
  IStatus destinationStatus;

  private Label labelName;

  private Label labelBeschreibung;

  private Text textName;

  private Label labelQuelle;

  private Text textPid;

  private Label labelQuelle1;

  private Text textOrtKonfig;

  private Button button;

  // private ConfigDataModel _dataModel;

  protected String _name;

  private Label labelQuelle2;

  private Text textOrtOrdner;

  private Button button2;

  private Label labelKodierung;

  private Text textKodierung;

  private Shell shell;

  private File _source;

  private File _dest;

  private Button button12;

  /**
   * Constructor for HolidayMainPage.
   */
  public KvAoeNeuStartSeite(String s)
  {
    super("Page1");
    setTitle("Neuer KV/AOE anlegen");
    setDescription("Schritt 1 : Ordnerstruktur kopieren");
    destinationStatus = new Status(IStatus.OK, "not_used", 0, "", null);
    timeStatus = new Status(IStatus.OK, "not_used", 0, "", null);
    // _dataModel = dataModel;

  }

  /**
   * @see IDialogPage#createControl(Composite)
   */
  public void createControl(Composite parent)
  {
    shell = parent.getShell();

    // create the composite to hold the widgets
    GridData gd;
    Composite composite = new Composite(parent, SWT.NULL);

    // create the desired layout for this wizard page
    GridLayout gl = new GridLayout();
    int ncol = 3;
    gl.numColumns = ncol;
    composite.setLayout(gl);

    GridData gridData21 = new GridData();
    gridData21.horizontalAlignment = GridData.FILL;
    gridData21.grabExcessHorizontalSpace = true;
    gridData21.verticalAlignment = GridData.CENTER;
    GridData gridData110 = new GridData();
    gridData110.horizontalAlignment = GridData.FILL;
    gridData110.grabExcessHorizontalSpace = true;
    gridData110.verticalAlignment = GridData.CENTER;
    GridData gridData111 = new GridData();
    gridData111.horizontalAlignment = GridData.FILL;
    gridData111.grabExcessHorizontalSpace = true;
    gridData111.verticalAlignment = GridData.CENTER;
    GridData gridData1 = new GridData();
    gridData1.horizontalAlignment = GridData.FILL;
    gridData1.grabExcessHorizontalSpace = true;
    gridData1.verticalAlignment = GridData.CENTER;
    labelName = new Label(composite, SWT.NONE);
    labelName.setText("Pid");
    textName = new Text(composite, SWT.BORDER);
    textName.setLayoutData(gridData1);

    Label filler0 = new Label(composite, SWT.NONE);
    //    
    // labelQuelle1 = new Label(composite, SWT.NONE);
    // labelQuelle1.setText("Quellverzeichnis");
    // textOrtKonfig = new Text(composite, SWT.BORDER);
    // textOrtKonfig.setLayoutData(gridData21);
    // button = new Button(composite, SWT.NONE);
    // button.setText("...");

    labelQuelle2 = new Label(composite, SWT.NONE);
    labelQuelle2.setText("Vorlage Ordnerstruktur");
    textOrtOrdner = new Text(composite, SWT.BORDER);
    textOrtOrdner.setLayoutData(gridData21);
    textOrtOrdner.setEnabled(false);

    button12 = new Button(composite, SWT.NONE);
    button12.setText("...");
    button12.addMouseListener(new MouseAdapter() {

      @Override
      public void mouseDown(MouseEvent e)
      {
        DirectoryDialog dlg = new DirectoryDialog(shell);

        dlg.setText("Ordner-Auswahl Dialog");

        dlg.setMessage("Ordner auswhlen");

        String dir = dlg.open();
        if (dir != null)
        {
          textOrtOrdner.setText(dir);
          KvAoeNeuAssistent wizard = (KvAoeNeuAssistent)getWizard();
          KvAoeNeuModell model = wizard.model;
          if (model._config != null){
            model._config.close();
            model._config = null;
          }
          
          
        }

        // startJobLadeDatenModell();
      }
    });
    // button2 = new Button(composite, SWT.NONE);
    // button2.setText("...");

    createLine(composite, ncol);

    // // Choice of transport
    kvButton = new Button(composite, SWT.RADIO);
    kvButton.setText("Konfigurationsverantwortlicher");
    gd = new GridData(GridData.FILL_HORIZONTAL);
    gd.horizontalSpan = ncol;
    kvButton.setLayoutData(gd);
    kvButton.setSelection(true);

    aoeButton = new Button(composite, SWT.RADIO);
    aoeButton.setText("Autarke Organisations Einheit");
    gd = new GridData(GridData.FILL_HORIZONTAL);
    gd.horizontalSpan = ncol;
    aoeButton.setLayoutData(gd);

    // set the composite as the control for this page
    setControl(composite);
    addListeners();
  }

  private void addListeners()
  {
    // textKodierung.addListener(SWT.Modify, this);
    textName.addListener(SWT.Modify, this);
    textOrtOrdner.addListener(SWT.Modify, this);
    // textPid.addListener(SWT.Modify, this);
    // textOrtKonfig.addListener(SWT.Modify, this);
    // button.addListener(SWT.Selection, this);
    // textOrtOrdner.addListener(SWT.Modify, this);
    // button2.addListener(SWT.Selection, this);
  }

  /**
   * @see Listener#handleEvent(Event)
   */
  public void handleEvent(Event event)
  {
    // Initialize a variable with the no error status
    // Status status = new Status(IStatus.OK, "not_used", 0, "", null);
    // If the event is triggered by the destination or departure fields
    // set the corresponding status variable to the right value

    if ((event.widget == textName))
    {
      // String pid = textName.getText();
    }
    if (event.widget == textOrtOrdner)
    {
      String sDir = textOrtOrdner.getText();
      _source = new File(sDir);
      if (_source != null && _source.isDirectory())
      {
        MultiStatus status = new MultiStatus(Activator.PLUGIN_ID, Status.OK, "berprfen der Verwaltungsdatei", null);
        MeldungenSpeicher.getInstanz().setStatus(status);
        
        File config = new File(_source.getAbsolutePath() + "/config");
        if (!config.exists())
          config = new File(_source.getAbsolutePath() + "/konfiguration");
        if (config.exists() && config.isDirectory())
        {
          File[] list = config.listFiles();
          
          boolean gefunden = false;
          
          for (File f : list)
          {
            if (f.getName().equals("verwaltungsdaten.xml"))
            {

              ManagementFile mgmtFile = null;
              try
              {
                
                mgmtFile = new ManagementFile(f);
                
                List<ConfigurationAreaManagementInfo> camis = mgmtFile.getAllConfigurationAreaManagementInfos();
                
                for (ConfigurationAreaManagementInfo cami : camis)
                {
                  // getDirectory() provoziert hier IllegalStateException, wenn Verwaltungsdatei falsche
                  // Pfadangabe(n) enthlt
                  File dir = cami.getDirectory();
                }
                
//                List<ConfigurationAreaManagementInfo> camis = mgmtFile.getAllConfigurationAreaManagementInfos();
                
                // System.out.println("camis: " + camis.size());
                //                    
                // for (ConfigurationAreaManagementInfo cami : camis)
                // {
                // System.out.println("cami: " + cami.getPid());
                // }
                mgmtFile.close();   
                
                gefunden = true;
                status.merge(new Status(Status.OK, Activator.PLUGIN_ID, "XML-Verwaltungsdatei OK."));
                
              }
              catch (Exception e)
              {
               
                
                status.merge(new Status(Status.ERROR, Activator.PLUGIN_ID, "Folgende Ausnahmen sind aufgetreten. ", e));
                
                MeldungenSpeicher.getInstanz().hinzufuegenMultimeldung(status, System.currentTimeMillis(), false);                
                
                String message = "Beim berprfen der Verwaltungsdatei sind Ausnahmen aufgetreten!";

//                MessageBox mb = new MessageBox(PlatformUI.getWorkbench().getDisplay().getActiveShell(), SWT.OK
                MessageBox mb = new MessageBox(getShell(), SWT.OK
                    | SWT.ICON_ERROR);
                mb.setText("Ungltige Verwaltungsdatei");
                mb.setMessage(message);
                mb.open();               

                textOrtOrdner.setText("");
                canFlipToNextPage();
                return;
              }
//              finally
//              {
//                if (mgmtFile != null){
//                  try
//                  {
//                    mgmtFile.close();                    
//                  }
//                  catch (IOException e)
//                  {
//                    // TODO Auto-generated catch block
//                    status.merge(new Status(Status.ERROR, Activator.PLUGIN_ID, "Fehler beim Schliessen der Verwaltungsdatei. ", e));
//                    
//                    MeldungenSpeicher.getInstanz().hinzufuegenMultimeldung(status, System.currentTimeMillis(), false);                
//                    
//                    String message = "Konnte Verwaltungsdatei nicht beenden!";
//
//                    MessageBox mb = new MessageBox(PlatformUI.getWorkbench().getDisplay().getActiveShell(), SWT.OK
//                        | SWT.ICON_ERROR);
//                    mb.setText("Fehler Verwaltungsdatei");
//                    mb.setMessage(message);
//                    mb.open();               
//                    e.printStackTrace();
//                    return;
//                    
//                  }   
//                }else{
//                  System.out.println("mgmt-File ist null");
//                }
//              }
            }
          }
          if (!gefunden){
            status.merge(new Status(Status.ERROR, Activator.PLUGIN_ID, "verwaltungsdaten.xml wurde nicht gefunden!"));
            
            MeldungenSpeicher.getInstanz().hinzufuegenMultimeldung(status, System.currentTimeMillis(), false);                
            
            String message = "Beim berprfen der Verwaltungsdatei sind Ausnahmen aufgetreten!";

            MessageBox mb = new MessageBox(getShell(), SWT.OK
                | SWT.ICON_ERROR);
            mb.setText("Keine Verwaltungsdatei");
            mb.setMessage(message);
            mb.open();               

            textOrtOrdner.setText("");
            canFlipToNextPage();
          }
        }
        else
        {
          String message = "Ordnervorlage enthlt keine entsprechenden Unterverzeichnisse !";

          MessageBox mb = new MessageBox(getShell(), SWT.OK
              | SWT.ICON_ERROR);
          mb.setText("Ungltige Ordnervorlage");
          mb.setMessage(message);
          mb.open();

          textOrtOrdner.setText("");
        }
      }
    }

    // // Show the most serious error
    // applyToStatusLine(findMostSevere());
    getWizard().getContainer().updateButtons();
  }

  /*
   * Returns the next page. Saves the values from this page in the model associated with the wizard. Initializes the
   * widgets on the next page.
   */

  public IWizardPage getNextPage()
  {

    String sDir = textOrtOrdner.getText();
    _source = new File(sDir);
    if (_source != null)
    {
      String s = _source.getParent();
      _dest = new File(s);
      if (_dest.isDirectory())
      {
        String[] list = _dest.list();
        for (String ss : list)
        {
          if (ss.equals(textName.getText()))
          {
            String message = "Die Pid fr den KV/AOE: " + textName.getText() + "wurde bereits vergeben";

            MessageBox mb = new MessageBox(PlatformUI.getWorkbench().getDisplay().getActiveShell(), SWT.OK
                | SWT.ICON_ERROR);
            mb.setText("Ungltige Pid");
            mb.setMessage(message);
            mb.open();

            return null;
          }

        }
      }

    }
    
//    KvAoeNeuAssistent wizard = (KvAoeNeuAssistent)getWizard();
//    KvAoeNeuModell model = wizard.model;
//    if (!textName.getText().equals(model.getPid())){
//      
//      System.out.println("Pid hat sich gendert -> Schliesse DM");
//      
//      if (model._config != null){
//        model._config.close();
//        model._config = null;
//      }
//    }
    

    saveDataToModel();

    String destNeu = _dest.getAbsolutePath() + "/" + textName.getText();

    _dest = new File(destNeu);

    KvAoeNeuAssistent wizard = (KvAoeNeuAssistent)getWizard();
    KvAoeNeuModell model = wizard.model;
    model._zielVerzeichnis = _dest.getAbsolutePath();
    model._quellVerzeichnis = _source.getAbsolutePath();

    if (_source != null && _dest != null)
    {

      final File fsource = _source;
      final File fdest = _dest;

      IRunnableWithProgress op2 = new IRunnableWithProgress() {

        @Override
        public void run(IProgressMonitor monitor) throws InvocationTargetException, InterruptedException
        {

          try
          {
            int i = 0;

            int cnt = KonfigAssDateiOperationen.copyDir(fsource, fdest, null, i, null, false);
            i = 0;
            cnt = KonfigAssDateiOperationen.copyDir(fsource, fdest, monitor, i, cnt, true);

          }
          catch (IOException e)
          {
            // TODO Auto-generated catch block
            e.printStackTrace();
          }
        }
      };
      try
      {
        WizardDialog2 container = (WizardDialog2)getContainer();
        container.run(true, true, op2);

      }
      catch (InvocationTargetException e)
      {
        // TODO Auto-generated catch block
        e.printStackTrace();
      }
      catch (InterruptedException e)
      {
        // TODO Auto-generated catch block
        e.printStackTrace();
      }
    }

    KvAoeNeuSeite1 page = ((KvAoeNeuAssistent)getWizard()).seite1;
    page.onEnterPage();
    return page;

    // return null;
  }

  /**
   * @see IWizardPage#canFlipToNextPage()
   */
  public boolean canFlipToNextPage()
  {
    if (getErrorMessage() != null)
      return false;

    if (isTextNonEmpty(textName) && isTextNonEmpty(textOrtOrdner))
    {
      return true;

    }
    return false;
  }

  /*
   * Saves the uses choices from this page to the model. Called on exit of the page
   */
  private void saveDataToModel()
  {
    // Gets the model
    KvAoeNeuAssistent wizard = (KvAoeNeuAssistent)getWizard();
    KvAoeNeuModell model = wizard.model;

    if (kvButton.getSelection())
      model.useKV = true;
    else
      model.useKV = false;

    if (aoeButton.getSelection())
      model.useAOE = true;
    else
      model.useAOE = false;

    model._pid = textName.getText();
    // model._quellVerzeichnis = textOrtKonfig.getText();
    model._zielVerzeichnis = textOrtOrdner.getText();

  }

  private static boolean isTextNonEmpty(Text t)
  {
    if (t != null)
    {
      String s = t.getText();
      if ((s != null) && (s.trim().length() > 0))
        return true;
    }
    return false;
  }

  private void createLine(Composite parent, int ncol)
  {
    Label line = new Label(parent, SWT.SEPARATOR | SWT.HORIZONTAL | SWT.BOLD);
    GridData gridData = new GridData(GridData.FILL_HORIZONTAL);
    gridData.horizontalSpan = ncol;
    line.setLayoutData(gridData);
  }

}
