/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.tkaaq;

import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchWizard;

import de.bsvrz.buv.plugin.tkabasis.hierarchie.ArrayInfo;
import de.bsvrz.buv.plugin.tkabasis.hierarchie.AtgInfo;
import de.bsvrz.buv.plugin.tkabasis.hierarchie.AttributInfo;
import de.bsvrz.buv.plugin.tkabasis.hierarchie.IAttributInfo;
import de.bsvrz.buv.plugin.tkabasis.hierarchie.IHierarchieObjektTyp;
import de.bsvrz.buv.plugin.tkabasis.hierarchie.MengeInfo;
import de.bsvrz.buv.plugin.tkabasis.hierarchie.TypInfo;
import de.bsvrz.dav.daf.main.config.SystemObjectType;

/**
 * Hierachieobjekt-Typen Verkehr MQ
 *   
 * @author Sans
 *
 */
public enum HOT_AQ implements IHierarchieObjektTyp
{ 
    Anzeige("Anzeige", new TypInfo[] { new TypInfo("typ.anzeige",	
    new AtgInfo[] 
	  {
	    new AtgInfo("atg.anzeige", true, new IAttributInfo[]
	    {
	      new AttributInfo("AnzeigeTyp"     , true, false, false, true, true, false),
	      new AttributInfo("RealisiertDurch", false, false, true, true, true, true)
	    }),
	  }, 
    new MengeInfo[] { new MengeInfo("menge.fahrStreifen", "FahrStreifen", false, null) }) 
    }),
//    AnzeigeSub("Anzeige", new TypInfo[] { new TypInfo("typ.anzeige", 
//      new AtgInfo[] 
//      {
//        new AtgInfo("atg.anzeige", true, new IAttributInfo[]
//        {
//          new AttributInfo("AnzeigeTyp"     , true, false, false, true, true, false),
//          new AttributInfo("RealisiertDurch", false, false, true, true, true, true)
//        }),
//      }, 
//      new MengeInfo[] { new MengeInfo("menge.fahrStreifen", "FahrStreifen", false, null) }) 
//    }),
    AnzeigeQuerschnitt("AnzeigeQuerschnitt", new TypInfo[] { new TypInfo("typ.anzeigeQuerschnitt", 
      new AtgInfo[] 
      {
        new AtgInfo("atg.anzeigeQuerschnitt", true, new IAttributInfo[]
        {
          new AttributInfo("AnzeigeQuerschnittTyp", true, false, false, true, true, false),
          new ArrayInfo("ZuHochbauSchrankSchacht", null),               
        }),
        new AtgInfo("atg.anzeigeQuerschnittNba", false, new IAttributInfo[]
        {
          new AttributInfo("VorgelagerterEntscheiderVorhanden", false, false, true, true, true, true)
        }),
        new AtgInfo("atg.punktKoordinaten", false, new IAttributInfo[]
        {
          new AttributInfo("x", true, false, false, true, true, false),
            new AttributInfo("y", true, false, false, true, true, false)        
        }),
        new AtgInfo("atg.punktLiegtAufLinienObjekt", false, new IAttributInfo[]
          {
          new AttributInfo("LinienReferenz", true, false, true, true, true, false),
              new AttributInfo("Offset", true, false, true, true, true, true)
          }),
      }, 
      new MengeInfo[] { new MengeInfo("menge.anzeigen", "Anzeigen", false, null) }) 
    }), 
//    AnzeigeQuerschnittSub("AnzeigeQuerschnitt", new TypInfo[] { new TypInfo("typ.anzeigeQuerschnitt", 
//      new AtgInfo[] 
//      {
//        new AtgInfo("atg.anzeigeQuerschnitt", true, new IAttributInfo[]
//        {
//          new AttributInfo("AnzeigeQuerschnittTyp", true, false, false, true, true, false),
//          new ArrayInfo("ZuHochbauSchrankSchacht", null),               
//        }),
//        new AtgInfo("atg.anzeigeQuerschnittNba", false, new IAttributInfo[]
//        {
//          new AttributInfo("VorgelagerterEntscheiderVorhanden", false, false, true, true, true, true)
//        }),
//        new AtgInfo("atg.punktKoordinaten", false, new IAttributInfo[]
//        {
//          new AttributInfo("x", true, false, false, true, true, false),
//            new AttributInfo("y", true, false, false, true, true, false)        
//        }),
//        new AtgInfo("atg.punktLiegtAufLinienObjekt", false, new IAttributInfo[]
//          {
//          new AttributInfo("LinienReferenz", true, false, true, true, true, false),
//              new AttributInfo("Offset", true, false, true, true, true, true)
//          }),
//      }, 
//      new MengeInfo[] { new MengeInfo("menge.anzeigen", "Anzeigen", false, null) }) 
//   }),
   AnzeigeQuerschnittTyp("AnzeigeQuerschnittTyp", new TypInfo[] { new TypInfo("typ.anzeigeQuerschnittTyp", 
     new AtgInfo[] 
     {
       new AtgInfo("atg.anzeigeQuerschnittTyp", true, new IAttributInfo[]
       {
         new ArrayInfo("MglicheBetriebsZustnde", null),             
       }),
     }, 
     null ) // Keine Mengen definiert
   }), 
   AnzeigeTyp("AnzeigeTyp", new TypInfo[] { new TypInfo("typ.anzeigeTyp", 
     new AtgInfo[] 
     {
       new AtgInfo("atg.anzeigeTyp", true, new IAttributInfo[]
       {
         new AttributInfo("KannFreieGrafik", false, false, true, true, true, true),
           new AttributInfo("AuflsungX", false, false, true, true, true, true),
         new AttributInfo("AuflsungY", false, false, true, true, true, true),
         new AttributInfo("Farbdarstellung", false, false, true, true, true, true),
         new AttributInfo("KannFreiText", false, false, true, true, true, true),
         new AttributInfo("TimeoutSchaltBildWechsel", false, false, true, true, true, true),
//         new ArrayInfo("Font", null),  
         new ArrayInfo("Font", false, false, false, false, false),  
         
//         new ArrayInfo("Font", new AttributInfo[]{ new AttributInfo("Font", false, false, true, false, false, true)}),    
       }),
       new AtgInfo("atg.anzeigeTypTextAusrichtung", false, new IAttributInfo[]
       {
         new AttributInfo("TextAusrichtung", false, false, true, true, true, true)
       }),     
     }, 
     new MengeInfo[] { new MengeInfo("menge.wvzInhalt", "WvzInhalt", false, null) }) 
   }), 
   Dirigent("Dirigent", new TypInfo[] { new TypInfo("typ.dirigent", 
      new AtgInfo[] 
      {
        new AtgInfo("atg.dirigent", false, new IAttributInfo[]
        {
          new AttributInfo("Dummy", true, false, true, true, true, true),         
        }),
      }, 
      new MengeInfo[] { new MengeInfo("menge.anzeigeQuerschnitte", "AnzeigeQuerschnitte", false, null) })
   }), 
   Zeichensatz("Zeichensatz", new TypInfo[] { new TypInfo("typ.font", 
     new AtgInfo[] 
     {
       new AtgInfo("atg.font", true, new IAttributInfo[]
       {
         new AttributInfo("Font", true, false, false, true, true, false),          
         new AttributInfo("SchrifthhePixel", true, false, false, true, true, false),          
         new AttributInfo("SchrifthheMillimeter", true, false, false, true, true, false),          
         new AttributInfo("ZeichenAbstandStandard", true, false, false, true, true, false),          
       }),
     }, 
     new MengeInfo[] { 
     new MengeInfo("menge.ligaturen", "Ligaturen", false, null),  
     new MengeInfo("menge.zeichen", "Zeichen", false, null)       
       })
   }),     
//   ZeichensatzSub("Zeichensatz", new TypInfo[] { new TypInfo("typ.font", 
//    new AtgInfo[] 
//    {
//      new AtgInfo("atg.font", true, new IAttributInfo[]
//      {
//        new AttributInfo("Font", true, false, false, true, true, false),          
//        new AttributInfo("SchrifthhePixel", true, false, false, true, true, false),          
//        new AttributInfo("SchrifthheMillimeter", true, false, false, true, true, false),          
//        new AttributInfo("ZeichenAbstandStandard", true, false, false, true, true, false),          
//      }),
//    }, 
//    new MengeInfo[] { 
//    new MengeInfo("menge.ligaturen", "Ligaturen", false, null),  
//    new MengeInfo("menge.zeichen", "Zeichen", false, null)       
//      })
//   }), 
   Ligaturen("Ligaturen", new TypInfo[] { new TypInfo("typ.ligaturen", 
     new AtgInfo[] 
     {
       new AtgInfo("atg.ligaturen", true, new IAttributInfo[]
       {
         new ArrayInfo("Zeichenabstand", null),            
         new ArrayInfo("Zeichen", null),           
       }),
     }, 
     null ) // Keine Mengen definiert
    }),  
//   LigaturenSub("Ligaturen", new TypInfo[] { new TypInfo("typ.ligaturen", 
//    new AtgInfo[] 
//    {
//      new AtgInfo("atg.ligaturen", true, new IAttributInfo[]
//      {
//        new ArrayInfo("Zeichenabstand", null),           
//        new ArrayInfo("Zeichen", null),          
//      }),
//    }, 
//    null ) // Keine Mengen definiert
//   }), 
   WechselText("WechselText", new TypInfo[] { new TypInfo("typ.wechseltext", 
     new AtgInfo[] 
     {
       new AtgInfo("atg.wechseltext", true, new IAttributInfo[]
       {
         new AttributInfo("Font", true, false, false, true, true, false),          
         new AttributInfo("TextAusrichtung", false, false, true, true, true, true),
         new ArrayInfo("Textdefinition", null),          
       }),
     }, 
     null ) // Keine Mengen definiert
   }),  
   WvzInhalt("WvzInhalt", new TypInfo[] { new TypInfo("typ.wvzInhalt", 
     new AtgInfo[] 
     {
       new AtgInfo("atg.wvzInhalt", true, new IAttributInfo[]
       {
         new AttributInfo("Bildinhalt", true, false, false, true, true, false),          
         new AttributInfo("Wechseltext", false, false, true, false, false, true),         
         new AttributInfo("IstGrafik", false, false, true, true, true, true),
//         new ArrayInfo("GrafikDarstellungen", null),
         new ArrayInfo("GrafikDarstellungen", false, false, false, false, false),  
       }),
     }, 
     null ) // Keine Mengen definiert
   }),
   WzgInhaltGrafik("WzgInhaltGrafik", new TypInfo[] { new TypInfo("typ.wzgInhaltGrafik", 
     new AtgInfo[] 
     {
       new AtgInfo("atg.wzgInhaltGrafik", true, new IAttributInfo[]
       {
         new AttributInfo("PositionX", false, false, true, true, true, true),          
         new AttributInfo("PositionY", false, false, true, true, true, true),          
         new AttributInfo("Skalierung", false, false, true, true, true, true),         
         new AttributInfo("Blinken", false, false, true, true, true, true),          
         new AttributInfo("Blinktakt", false, false, true, true, true, true),          
         new AttributInfo("URL", true, false, false, true, true, true)         
       }),
     }, 
     null ) // Keine Mengen definiert
   }), 
   Zeichen("Zeichen", new TypInfo[] { new TypInfo("typ.zeichen", 
     new AtgInfo[] 
     {
       new AtgInfo("atg.zeichen", true, new IAttributInfo[]
       {
         new AttributInfo("Zeichenname", true, false, false, true, true, false),                        
         new AttributInfo("Zeichenbreite", false, false, true, true, true, true)         
       }),
     }, 
     null ) // Keine Mengen definiert
    }),  
//  ZeichenSub("Zeichen", new TypInfo[] { new TypInfo("typ.zeichen", 
//    new AtgInfo[] 
//    {
//      new AtgInfo("atg.zeichen", true, new IAttributInfo[]
//      {
//        new AttributInfo("Zeichenname", true, false, false, true, true, false),                        
//        new AttributInfo("Zeichenbreite", false, false, true, true, true, true)         
//      }),
//    }, 
//    null ) // Keine Mengen definiert
//   }),  
   FS("FS", new TypInfo[] { new TypInfo("typ.fahrStreifen", 
	    null,  // Keine Attributgruppen definiert
	    null ) // Keine Mengen definiert        
    }, 
    true),
//   FSSub("FS", new TypInfo[] { new TypInfo("typ.fahrStreifen", 
//      null,  // Keine Attributgruppen definiert
//      null ) // Keine Mengen definiert  
//    }, 
//   true),             
  ; 

  
  /**
   * Name des HOT - wird in der Navigationsdarstellung verwendet
   */
  private String _name;
  
  /**
   * Die Systemobjekt-Typen, die von diesem HOT verwendet werden
   */
  private List<String> _typen = new Vector<String>();
  
  /**
   * Die Typinfos zu den Systemobjekttypen
   */
  private Map<String, TypInfo> _typInfos = new HashMap<String, TypInfo>();

  /**
   * Flagge die anzeigt ob die Bildungsregeln angewendet werden sollen
   */
  private boolean _bildungsRegelGefordert;
  
    
  /**
   * Erzeugen eines neuen HOT_MQ
   * 
   * @param name Name des HOT
   * @param typInfos Systemobjekt-Typen und zugehrige Informationen, 
   * die von diesem HOT verwendet werden
   */
  private HOT_AQ(String name, TypInfo[] typInfos)
  {
    _name = name;
    if (typInfos != null)
    {  
    	for (TypInfo  info: typInfos)
    	{	
    		_typen.add(info.getTyp());
    		_typInfos.put(info.getTyp(), info);
    	}	
    }  
  }
  
  /**
   * Erzeugen eines neuen HOT_MQ
   * 
   * @param name Name des HOT
   * @param typInfos Systemobjekt-Typen und zugehrige Informationen, 
   * die von diesem HOT verwendet werden
   */
  private HOT_AQ(String name, TypInfo[] typInfos, boolean bildungsRegelGefordert)
  {
    this(name, typInfos); 
    _bildungsRegelGefordert = bildungsRegelGefordert;
  }
  
  /**
   * Text-Reprsentation fr diesen HOT
   * 
   * @return den Namen des HOT - wird in der Navigationsdarstellung verwendet
   */
  @Override
  public String toString()
  {
    return getName();
  }
    
  /**
	 * @see IHierarchieObjektTyp#getName()
	 */
  public String getName()
  {
    return _name;
  }
  
  /**
	 * @see IHierarchieObjektTyp#getSymbolName()
	 */
  public String getSymbolName()
  {
  	return super.toString();
  }
  
  /**
	 * @see IHierarchieObjektTyp#getTypen()
	 */
  public List<String> getTypen()
  {
    return Collections.unmodifiableList(_typen); 
  }
  
  
  /**
	 * @see IHierarchieObjektTyp#getTypInfo(String)
	 */
  public TypInfo getTypInfo(String typ)
  {
  	return _typInfos.get(typ);
  }

  /**
	 * @see IHierarchieObjektTyp#getTypInfo(SystemObjectType)
	 */
  public TypInfo getTypInfo(SystemObjectType sot)
  {
  	TypInfo result = getTypInfo(sot.getPid());
  	
  	if (result == null && !sot.isBaseType())
  	{
  		for (SystemObjectType superTyp: sot.getSuperTypes())
  		{
  			if (superTyp.isConfigurating())
  			{
  				 result = getTypInfo(superTyp);
  				 if (result != null)
  				 {
  					 break;
  				 }
  			}
  		}
  	}
  	
  	return result;
  }
  
  @Override
  public boolean isSystemObjektVorhanden()
  {
    // TODO Auto-generated method stub    
    return _bildungsRegelGefordert;
  }
  
  public boolean isSystemObjektNichtAenderbar()
  {
  	return isSystemObjektVorhanden();
  }
  
}	
