/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.tkabasis;


/**
 * Interface, das von Clients implementiert werden muss um dem Legenden Plug-In
 * die anzuzeigende Legende als Composite zu bergeben. Die Methoden sind
 * Callback-Methoden, welche von dem Legenden-Plugin aufgerufen werden.
 * 
 * @author Pittner
 *
 */
public interface ITKABasisComposite
{
  /**
   * Holt die PluginId des Plugins, welches das Composite fr die Legende liefert
   * 
   * @return Id
   */
  public String holePluginId();
  
  /**
   * Holt die PluginId des Plugins, welches das Composite fr die Legende liefert
   * 
   * @return Id
   */
  public void setReiterName(String name);
  
//  /**
//   * Holt die PluginId des Plugins, welches das Composite fr die Legende liefert
//   * 
//   * @return Id
//   */
//  public String holeName();
//  
//  /**
//   * Erzeugt das Composite welches als Legende angezeigt werden soll.
//   * 
//   * @param parent 
//   *            das Eltern-Composite, welches das anzuzeigende Composite aufnimmt
//   * @return Composite 
//   *            wird als Legende angezeigt
//   */
//  public Composite holeProducerComposite(Composite parent);  
  
  /**
   * Erzeugt das Composite welches als Legende angezeigt werden soll.
   * 
   * @param parent 
   *            das Eltern-Composite, welches das anzuzeigende Composite aufnimmt
   * @return Composite 
   *            wird als Legende angezeigt
   */
  public void erzeugeTKABasisView(TKABasisView view);  
  
   
}
