/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.tkabasis.datenbereich.datenbasis;

import de.bsvrz.dav.daf.main.config.SystemObject;

public class GtmListenElementObjekt
	{
		private String name = null;

		private SystemObject systemObject = null;

	 

		public GtmListenElementObjekt(SystemObject sysObj)
		{
			setSystemObjekt(sysObj);
		}

		public String getName()
		{
			return name;
		}

		private void setName(String name)
		{
			this.name = name;
		}

		public SystemObject getSystemObjekt()
		{
			return systemObject;
		}

		private void setSystemObjekt(SystemObject systemObject)
		{
			if (systemObject != null)
			{
				this.systemObject = systemObject;
				// this.setName(systemObject.getName());
				// Name, pid, id
				String tempName = "";
				if (systemObject.getPid() != null && systemObject.getPid().length() > 0)
					tempName = tempName + systemObject.getPid() + " ";
				if (systemObject.getName() != null && systemObject.getName().length() > 0)
					tempName = tempName + "(" + systemObject.getName() + ") ";
				if (systemObject.getId() > 0)
					tempName = tempName + "[" + String.valueOf(systemObject.getId()) + "]";
				this.setName(tempName);
			}
		}
		
	public String toString()
	{
		return getName();
	}
	}