/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.tkabasis.hierarchie;

import org.eclipse.core.runtime.IStatus;

/**
 * Kapselung eines Hierarchieobjekts mit zugeordnetem Status
 * @author Sans
 *
 */
public class HOMitStatus
{

  /**
   * Das Hierarchieobjekt
   */
  private HierarchieObjekt _ho;
  
  /**
   * Die dem referenzierten Hierarchieobjekt zugeordnete Instanz vom Typ IStatus
   */
  private IStatus _status;

  /**
   * Erzeugen einer neuen Instanz vom Typ HOMitStatus
   * 
   * @param ho das Hierarchieobjekt
   * @param status die dem Hierarchieobjekt zugeordnete Instanz vom Typ IStatus
   */
  public HOMitStatus(HierarchieObjekt ho, IStatus status)
  {
    _ho = ho;
    _status = status;
  }
  
  /**
   * 
   * @return das Hierarchieobjekt
   */
  public HierarchieObjekt getHO()
  {
    return _ho;
  }
  
  /**
   * 
   * @return die dem referenzierten Hierarchieobjekt zugeordnete Instanz vom Typ IStatus
   */
  public IStatus getStatus()
  {
    return _status;
  }
}
